diff --git a/base/java-tools/src/com/netscape/cmstools/CMCRequest.java b/base/java-tools/src/com/netscape/cmstools/CMCRequest.java
index bca569b..4485f47 100644
--- a/base/java-tools/src/com/netscape/cmstools/CMCRequest.java
+++ b/base/java-tools/src/com/netscape/cmstools/CMCRequest.java
@@ -1214,116 +1515,223 @@ public class CMCRequest {
                 System.out.println("got signerCert: "+ certname.toString());
             }
 
-            String[] requests = new String[num];
-            for (int i = 0; i < num; i++) {
-                BufferedReader inputBlob = null;
-                try {
-                    inputBlob = new BufferedReader(new InputStreamReader(
-                            new BufferedInputStream(new FileInputStream(ifiles[i]))));
-                } catch (FileNotFoundException e) {
-                    System.out.println("CMCRequest:  can't find file " +
-                            ifiles[i] + ":\n" + e);
-                } catch (Exception e) {
-                    e.printStackTrace();
-                    System.exit(1);
-                }
-                // (3) Read the entire contents of the specified BASE 64 encoded
-                //     blob into a String() object throwing away any
-                //     headers beginning with HEADER and any trailers beginning
-                //     with TRAILER
-                String asciiBASE64BlobChunk = "";
-                StringBuffer asciiBASE64Blob = new StringBuffer();
-
-                try {
-                    while ((asciiBASE64BlobChunk = inputBlob.readLine()) != null) {
-                        if (!(asciiBASE64BlobChunk.startsWith(HEADER)) &&
-                                !(asciiBASE64BlobChunk.startsWith(TRAILER))) {
-                            asciiBASE64Blob.append(asciiBASE64BlobChunk.trim());
-                        }
+            //cfu
+            ContentInfo cmcblob = null;
+            PKIData pkidata = null;
+            if (decryptedPopEnable.equalsIgnoreCase("true")) {
+                PrivateKey privk = null;
+                if (privKeyId == null) {
+                    System.out.println("ecryptedPop.enable = true, but privKeyId not specified.");
+                    printUsage();
+                } else {
+                    System.out.println("got privKeyId: " + privKeyId);
+
+                    byte[] keyIDb = CryptoUtil.string2byte(privKeyId);
+
+                    privk = CryptoUtil.findPrivateKeyFromID(keyIDb);
+
+                    if (privk != null) {
+                        System.out.println("got private key");
+                        // now we can use this to decrypt encryptedPOP
+                    } else {
+                        System.out.println("error getting private key null");
+                        System.exit(1);
                     }
-                    requests[i] = asciiBASE64Blob.toString();
-                } catch (IOException e) {
-                    System.out.println("CMCRequest:  Unexpected BASE64 " +
-                            "encoded error encountered in readLine():\n" +
-                            e);
                 }
-                // (4) Close the DataInputStream() object
-                try {
-                    inputBlob.close();
-                } catch (IOException e) {
-                    System.out.println("CMCRequest():  Unexpected BASE64 " +
-                            "encoded error encountered in close():\n" + e);
+
+                if (encryptedPopResponseFile == null) {
+                    System.out.println("ecryptedPop.enable = true, but encryptedPopResponseFile is not specified.");
+                    printUsage();
                 }
-            }
 
-            SEQUENCE controlSeq = new SEQUENCE();
-            int bpid = 1;
-            if (confirmCertEnable.equalsIgnoreCase("true")) {
-                if (confirmCertIssuer.length() == 0 || confirmCertSerial.length() == 0) {
-                    System.out.println("Illegal parameters for confirm certificate acceptance control");
+                if (decryptedPopRequestFile == null) {
+                    System.out.println("ecryptedPop.enable = true, but decryptedPopRequestFile is not specified.");
                     printUsage();
+                }
+                ofilename = decryptedPopRequestFile;
+
+                // now start processing decryptedPOP
+                Object[] encryptedPopInfo = processEncryptedPopResponse(encryptedPopResponseFile);
+                if (encryptedPopInfo == null) {
+                    System.out.println("processEncryptedPopResponse() returns null");
                     System.exit(1);
                 }
-                bpid = addConfirmCertAttr(bpid, controlSeq, confirmCertIssuer, confirmCertSerial);
-            }
+                pkidata = constructDecryptedPopRequest(encryptedPopInfo, tokenName, privk);
 
-            if (lraPopWitnessEnable.equalsIgnoreCase("true")) {
-                if (bodyPartIDs.length() == 0) {
-                    System.out.println("Illegal parameters for Lra Pop Witness control");
-                    printUsage();
+                if (pkidata == null) {
+                    System.out.println("after constructDecryptedPopRequest, pkidata null. no good");
                     System.exit(1);
                 }
+            } else { // !decryptedPopEnable
 
-                bpid = addLraPopWitnessAttr(bpid, controlSeq, bodyPartIDs);
-            }
+                if (ifilename == null) {
+                    System.out.println("Missing input filename for PKCS10 or CRMF.");
+                    printUsage();
+                }
 
-            if (getCertEnable.equalsIgnoreCase("true")) {
-                if (getCertIssuer.length() == 0 || getCertSerial.length() == 0) {
-                    System.out.println("Illegal parameters for get certificate control");
+                int num = 0;
+                if (numRequests == null) {
+                    System.out.println("Missing numRequests.");
                     printUsage();
-                    System.exit(1);
+                } else {
+                    try {
+                        num = Integer.parseInt(numRequests);
+                    } catch (Exception ee) {
+                        System.out.println("numRequests must be integer");
+                        System.exit(1);
+                    }
                 }
 
-                bpid = addGetCertAttr(bpid, controlSeq, getCertIssuer, getCertSerial);
-            }
+                StringTokenizer tokenizer = new StringTokenizer(ifilename, " ");
+                String[] ifiles = new String[num];
+                for (int i = 0; i < num; i++) {
+                    String ss = tokenizer.nextToken();
+                    ifiles[i] = ss;
+                    if (ss == null) {
+                        System.out.println("Missing input file for the request.");
+                        System.exit(1);
+                    }
+                }
 
-            if (dataReturnEnable.equalsIgnoreCase("true")) {
-                if (dataReturnData.length() == 0) {
-                    System.out.println("Illegal parameters for data return control");
+                if (ofilename == null) {
+                    System.out.println("Missing output filename for the CMC request.");
                     printUsage();
-                    System.exit(1);
                 }
 
-                bpid = addDataReturnAttr(bpid, controlSeq, dataReturnData);
-            }
+                if (format == null) {
+                    System.out.println("Missing format.");
+                    printUsage();
+                }
+                String[] requests = new String[num];
+                for (int i = 0; i < num; i++) {
+                    BufferedReader inputBlob = null;
+                    try {
+                        inputBlob = new BufferedReader(new InputStreamReader(
+                                new BufferedInputStream(new FileInputStream(ifiles[i]))));
+                    } catch (FileNotFoundException e) {
+                        System.out.println("CMCRequest:  can't find file " +
+                                ifiles[i] + ":\n" + e);
+                    } catch (Exception e) {
+                        e.printStackTrace();
+                        System.exit(1);
+                    }
+                    // (3) Read the entire contents of the specified BASE 64 encoded
+                    //     blob into a String() object throwing away any
+                    //     headers beginning with HEADER and any trailers beginning
+                    //     with TRAILER
+                    String asciiBASE64BlobChunk = "";
+                    StringBuffer asciiBASE64Blob = new StringBuffer();
+
+                    try {
+                        while ((asciiBASE64BlobChunk = inputBlob.readLine()) != null) {
+                            if (!(asciiBASE64BlobChunk.startsWith(HEADER)) &&
+                                    !(asciiBASE64BlobChunk.startsWith(TRAILER))) {
+                                asciiBASE64Blob.append(asciiBASE64BlobChunk.trim());
+                            }
+                        }
+                        requests[i] = asciiBASE64Blob.toString();
+                    } catch (IOException e) {
+                        System.out.println("CMCRequest:  Unexpected BASE64 " +
+                                "encoded error encountered in readLine():\n" +
+                                e);
+                    }
+                    // (4) Close the DataInputStream() object
+                    try {
+                        inputBlob.close();
+                    } catch (IOException e) {
+                        System.out.println("CMCRequest():  Unexpected BASE64 " +
+                                "encoded error encountered in close():\n" + e);
+                    }
+                }
 
-            if (senderNonceEnable.equalsIgnoreCase("true"))
-                bpid = addSenderNonceAttr(bpid, controlSeq, senderNonce);
+                SEQUENCE controlSeq = new SEQUENCE();
+                int bpid = 1;
+                if (confirmCertEnable.equalsIgnoreCase("true")) {
+                    if (confirmCertIssuer.length() == 0 || confirmCertSerial.length() == 0) {
+                        System.out.println("Illegal parameters for confirm certificate acceptance control");
+                        printUsage();
+                        System.exit(1);
+                    }
+                    bpid = addConfirmCertAttr(bpid, controlSeq, confirmCertIssuer, confirmCertSerial);
+                }
 
-            if (popLinkWitnessEnable.equalsIgnoreCase("true"))
-                bpid = addPopLinkWitnessAttr(bpid, controlSeq);
+                if (lraPopWitnessEnable.equalsIgnoreCase("true")) {
+                    if (bodyPartIDs.length() == 0) {
+                        System.out.println("Illegal parameters for Lra Pop Witness control");
+                        printUsage();
+                        System.exit(1);
+                    }
 
-            SEQUENCE otherMsgSeq = new SEQUENCE();
-            if (revRequestEnable.equalsIgnoreCase("true")) {
-                if (revRequestIssuer.length() == 0 || revRequestSerial.length() == 0 ||
-                        revRequestReason.length() == 0) {
-                    System.out.println("Illegal parameters for revRequest control");
-                    printUsage();
-                    System.exit(1);
+                    bpid = addLraPopWitnessAttr(bpid, controlSeq, bodyPartIDs);
+                }
+
+                if (getCertEnable.equalsIgnoreCase("true")) {
+                    if (getCertIssuer.length() == 0 || getCertSerial.length() == 0) {
+                        System.out.println("Illegal parameters for get certificate control");
+                        printUsage();
+                        System.exit(1);
+                    }
+
+                    bpid = addGetCertAttr(bpid, controlSeq, getCertIssuer, getCertSerial);
                 }
 
-                bpid = addRevRequestAttr(bpid, controlSeq, otherMsgSeq, token, tokenName, revCertNickname,
-                        revRequestIssuer, revRequestSerial, revRequestReason, revRequestSharedSecret,
-                        revRequestComment, revRequestInvalidityDatePresent, cm);
+                if (dataReturnEnable.equalsIgnoreCase("true")) {
+                    if (dataReturnData.length() == 0) {
+                        System.out.println("Illegal parameters for data return control");
+                        printUsage();
+                        System.exit(1);
+                    }
+
+                    bpid = addDataReturnAttr(bpid, controlSeq, dataReturnData);
+                }
+
+                if (senderNonceEnable.equalsIgnoreCase("true"))
+                    bpid = addSenderNonceAttr(bpid, controlSeq, senderNonce);
+
+                if (popLinkWitnessEnable.equalsIgnoreCase("true"))
+                    bpid = addPopLinkWitnessAttr(bpid, controlSeq);
+
+                SEQUENCE otherMsgSeq = new SEQUENCE();
+                if (revRequestEnable.equalsIgnoreCase("true")) {
+                    if (revRequestIssuer.length() == 0 || revRequestSerial.length() == 0 ||
+                            revRequestReason.length() == 0) {
+                        System.out.println("Illegal parameters for revRequest control");
+                        printUsage();
+                        System.exit(1);
+                    }
+
+                    bpid = addRevRequestAttr(bpid, controlSeq, otherMsgSeq, token, tokenName, revCertNickname,
+                            revRequestIssuer, revRequestSerial, revRequestReason, revRequestSharedSecret,
+                            revRequestComment, revRequestInvalidityDatePresent, cm);
+                }
+
+                // create the request PKIData
+                pkidata = createPKIData(
+                        requests,
+                        format, transactionMgtEnable, transactionMgtId,
+                        identificationEnable, identification,
+                        identityProofEnable, identityProofSharedSecret,
+                        identityProofV2Enable, witnessSharedSecret,
+                        identityProofV2hashAlg, identityProofV2macAlg,
+                        controlSeq, otherMsgSeq, bpid);
+
+                if (pkidata == null) {
+                    System.out.println("pkidata null after createPKIData(). Exiting with error");
+                    System.exit(1);
+                }
             }
 
-            ContentInfo cmcblob = getCMCBlob(signerCert, tokenName, nickname, requests, format,
-                    cm, transactionMgtEnable, transactionMgtId,
-                    identificationEnable, identification,
-                    identityProofEnable, identityProofSharedSecret,
-                    identityProofV2Enable, identityProofV2SharedSecret,
-                    identityProofV2hashAlg, identityProofV2macAlg,
-                    controlSeq, otherMsgSeq, bpid);
+            // sign the request
+            SignedData signedData = signData(signerCert, tokenName, nickname, cm, pkidata);
+            if (signedData == null) {
+                System.out.println("signData() returns null. Exiting with error");
+                System.exit(1);
+            }
+            cmcblob = getCMCBlob(signedData);
+            if (cmcblob == null) {
+                System.out.println("getCMCBlob() returns null. Exiting with error");
+                System.exit(1);
+            }
 
             // (6) Finally, print the actual CMC blob to the
             //     specified output file
diff --git a/base/java-tools/src/com/netscape/cmstools/CMCResponse.java b/base/java-tools/src/com/netscape/cmstools/CMCResponse.java
index 7bbba87..4c74934 100644
--- a/base/java-tools/src/com/netscape/cmstools/CMCResponse.java
+++ b/base/java-tools/src/com/netscape/cmstools/CMCResponse.java
@@ -34,6 +34,7 @@ import org.mozilla.jss.asn1.SEQUENCE;
 import org.mozilla.jss.asn1.SET;
 import org.mozilla.jss.pkix.cert.Certificate;
 import org.mozilla.jss.pkix.cmc.CMCStatusInfo;
+import org.mozilla.jss.pkix.cmc.EncryptedPOP;
 import org.mozilla.jss.pkix.cmc.OtherInfo;
 import org.mozilla.jss.pkix.cmc.PendInfo;
 import org.mozilla.jss.pkix.cmc.ResponseBody;
@@ -140,12 +141,27 @@ public class CMCResponse {
                             else if (t == OtherInfo.PEND) {
                                 System.out.println("   OtherInfo type: PEND");
                                 PendInfo pi = oi.getPendInfo();
+                                if (pi == null) {
+                                    System.out.println("PendInfo null...skipping");
+                                    continue;
+                                } else
+                                    System.out.println("PendInfo present...processing...");
                                 if (pi.getPendTime() != null) {
                                     String datePattern = "dd/MMM/yyyy:HH:mm:ss z";
                                     SimpleDateFormat dateFormat = new SimpleDateFormat(datePattern);
                                     Date d = pi.getPendTime().toDate();
                                     System.out.println("   Date: " + dateFormat.format(d));
                                 }
+                                OCTET_STRING pendToken = pi.getPendToken();
+                                if (pendToken != null) {
+                                    byte reqId[] = pendToken.toByteArray();
+                                    String reqIdString = new String(reqId);
+                                    System.out.println("   Pending request id: " + reqIdString);
+                                } else {
+                                    System.out.println("pendToken not in response");
+                                    System.exit(1);
+                                }
+
                             }
                         } else if (st == CMCStatusInfo.SUCCESS) {
                             System.out.println("   Status: SUCCESS");
@@ -200,6 +216,16 @@ public class CMCResponse {
                         s.append(" ");
                     }
                     System.out.println(s);
+                } else if (type.equals(OBJECT_IDENTIFIER.id_cmc_encryptedPOP)) {
+                    System.out.println("Control #" + i + ": CMC encrypted POP");
+                    System.out.println("   OID: " + type.toString());
+                    SET encryptedPOPvals = taggedAttr.getValues();
+
+                    EncryptedPOP encryptedPOP =
+                        (EncryptedPOP) (ASN1Util.decode(EncryptedPOP.getTemplate(),
+                            ASN1Util.encode(encryptedPOPvals.elementAt(0))));
+                    System.out.println("after encryptedPOP encode");
+
                 }
             }
         } catch (Exception e) {
diff --git a/base/java-tools/src/com/netscape/cmstools/CRMFPopClient.java b/base/java-tools/src/com/netscape/cmstools/CRMFPopClient.java
index 5e53bee..fafe956 100644
--- a/base/java-tools/src/com/netscape/cmstools/CRMFPopClient.java
+++ b/base/java-tools/src/com/netscape/cmstools/CRMFPopClient.java
@@ -433,6 +433,13 @@ public class CRMFPopClient {
                 throw new Exception("Unknown algorithm: " + algorithm);
             }
 
+            // print out keyid to be used in cmc decryptPOP
+            PrivateKey privateKey = (PrivateKey) keyPair.getPrivate();
+            @SuppressWarnings("deprecation")
+            byte id[] = privateKey.getUniqueID();
+            String kid = CryptoUtil.byte2string(id);
+            System.out.println("Keypair private key id: " + kid);
+
             if (verbose) System.out.println("Creating certificate request");
             CertRequest certRequest = client.createCertRequest(token, transportCert, algorithm, keyPair, subject);
 
